<div class="main-wrapper" fxLayout="column" fxLayoutAlign="start none">

    <div class="mt" fxLayout="row" fxLayoutAlign="space-around center">
        <h1>Logs</h1>
    </div>

    <div class="" fxLayout="row" fxLayoutAlign="space-around center">

        <div class="ml5" fxLayout="column" fxFlex="25">
            <mat-form-field appearance="fill">
                <mat-label>Date from</mat-label>
                <input matInput [matDatepicker]="dateFromInput" [formControl]="dateFrom">
                <mat-datepicker-toggle matSuffix [for]="dateFromInput"></mat-datepicker-toggle>
                <mat-datepicker #dateFromInput></mat-datepicker>
            </mat-form-field>

            <mat-form-field appearance="fill">
                <mat-label>Date to</mat-label>
                <input matInput [matDatepicker]="dateToInput" [formControl]="dateTo">
                <mat-datepicker-toggle matSuffix [for]="dateToInput"></mat-datepicker-toggle>
                <mat-datepicker #dateToInput></mat-datepicker>
            </mat-form-field>
        </div>

        <div class="ml5" fxLayout="column" fxFlex="25">
            <mat-form-field class="" appearance="fill">
                <mat-label>EndPoint</mat-label>
                <input matInput type="text" [formControl]="endPoint">
                <button mat-button *ngIf="endPoint.value" matSuffix mat-icon-button aria-label="Clear"
                    (click)="endPoint.patchValue(null)">
                    <mat-icon>close</mat-icon>
                </button>
            </mat-form-field>

            <mat-form-field class="" appearance="fill">
                <mat-label>Method</mat-label>
                <input matInput type="text" [formControl]="method">
                <button mat-button *ngIf="method.value" matSuffix mat-icon-button aria-label="Clear"
                    (click)="method.patchValue(null)">
                    <mat-icon>close</mat-icon>
                </button>
            </mat-form-field>
        </div>

        <div class="ml5" fxLayout="column" fxFlex="25">
            <mat-form-field class="" appearance="fill">
                <mat-label>Status code</mat-label>
                <input matInput type="text" [formControl]="statusCode">
                <button mat-button *ngIf="statusCode.value" matSuffix mat-icon-button aria-label="Clear"
                    (click)="statusCode.patchValue(null)">
                    <mat-icon>close</mat-icon>
                </button>
            </mat-form-field>

            <button mat-stroked-button style="margin-bottom: 15px;" color="secondary" (click)="reset()">Reset</button>

        </div>



        <div class="ml5" fxLayout="column" fxFlex="25">

            <mat-form-field class="" appearance="fill">
                <mat-label>Status message</mat-label>
                <input matInput type="text" [formControl]="statusMessage">
                
                <button mat-button *ngIf="statusMessage.value" matSuffix mat-icon-button aria-label="Clear"
                    (click)="statusMessage.patchValue(null)">
                    <mat-icon>close</mat-icon>
                </button>
            </mat-form-field>

            <button mat-stroked-button style="margin-bottom: 15px;" color="primary"
                (click)="applyFilter()">Search</button>
        </div>
    </div>

    <div class="mat-elevation-z8">
        <table mat-table matTableExporter [dataSource]="dataSource" matSort #exporter="matTableExporter">

            <!-- uuid Column -->
            <ng-container matColumnDef="uuid">
                <th mat-header-cell *matHeaderCellDef mat-sort-header> uuid </th>
                <td mat-cell *matCellDef="let row"> {{row.uuid}} </td>
            </ng-container>

            <!-- date Column -->
            <ng-container matColumnDef="date">
                <th mat-header-cell *matHeaderCellDef mat-sort-header> Date </th>
                <td mat-cell *matCellDef="let row"> {{row.date | date: 'dd/MM/yyyy HH:mm:ss'}} </td>
            </ng-container>

            <!-- endPoint Column -->
            <ng-container matColumnDef="endPoint">
                <th mat-header-cell *matHeaderCellDef mat-sort-header> EndPoint </th>
                <td mat-cell *matCellDef="let row"> {{row.endPoint}} </td>
            </ng-container>

            <!-- method Column -->
            <ng-container matColumnDef="method">
                <th mat-header-cell *matHeaderCellDef mat-sort-header> Method </th>
                <td mat-cell *matCellDef="let row"> {{row.method}} </td>
            </ng-container>

            <!-- statusCode Column -->
            <ng-container matColumnDef="statusCode">
                <th mat-header-cell *matHeaderCellDef mat-sort-header> Status code </th>
                <td mat-cell *matCellDef="let row" [style.color]="row.color"> {{row.statusCode}} </td>
            </ng-container>

            <!-- statusMessage Column -->
            <ng-container matColumnDef="statusMessage">
                <th mat-header-cell *matHeaderCellDef mat-sort-header> Status message </th>
                <td mat-cell *matCellDef="let row" [style.color]="row.color"> {{row.statusMessage}} </td>
            </ng-container>

            <!-- statusMessage Column -->
            <ng-container matColumnDef="actions">
                <th mat-header-cell *matHeaderCellDef mat-sort-header> </th>
                <td mat-cell *matCellDef="let row" [style.color]="row.color">
                    <button mat-mini-fab color="primary" aria-label="View details" (click)="gotoDetails(row)">
                        <mat-icon>view_list</mat-icon>
                    </button>
                </td>
            </ng-container>

            <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
            <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>

            <!-- Row shown when there is no matching data. -->
            <tr class="mat-row" *matNoDataRow>
                <td class="mat-cell" colspan="6">No data matching the filter </td>
            </tr>
        </table>

        <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]" pageIndex="2"></mat-paginator>
        <button mat-raised-button
            (click)="exporter.exportTable('xlsx', {fileName:'Export'})">Excel</button>
        <button mat-raised-button (click)="exporter.exportTable('csv', {fileName:'Export'})">Csv</button>
        <button mat-raised-button (click)="exporter.exportTable('json', {fileName:'Export'})">Json</button>
        <button mat-raised-button (click)="exporter.exportTable('txt', {fileName:'Export'})">Txt</button>
    </div>

</div>